package org.windoop;

import java.io.IOException;

import org.apache.hadoop.io.*;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Mapper.Context;
import org.apache.hadoop.mapreduce.lib.input.FileSplit;
import org.apache.log4j.Logger;

public class FileComparatorMapper extends 
	//Mapper<NullWritable, BytesWritable, Text, Text> {
	Mapper<Object, Text, Text, Text> {
	private static Logger log = Logger.getLogger(FileComparatorMapper.class);
	private String filepath;
	private String filename;
	//private String filetype;
	String PubMedID;
	
	protected void setup(Context context) {		
		filepath = ((FileSplit) context.getInputSplit()).getPath().toString();
		filename = ((FileSplit) context.getInputSplit()).getPath().getName();
		//filetype = filename.substring(filename.lastIndexOf(".")).toLowerCase();
		log.info("Mapper Setup " + filename);
	}
	
	protected void cleanup(Context context) {// called at the end of the task
    	log.info("Mapper Cleanup");
	}
	
	//public void map(NullWritable key, BytesWritable value, Context context)throws IOException, InterruptedException, NullPointerException {
	public void map(Object key, Text value, Context context)throws IOException, InterruptedException, NullPointerException {
			
		String reducerKey = "";
		try {
			
			// 25086856##2014-8-5##Identification and characterization of a novel splice-site mutation in the Wilson disease gene.##This study aimed to identify aberrant transcripts of the new splice-site mutation c.3244-2A&gt;C in the Wilson disease (WD) gene (ATPase, Cu++ transporting, beta polypeptide, ATP7B) and discuss its genotype and clinical phenotype. DNA and RNA were extracted from peripheral blood lymphocytes, amplified by polymerase chain reaction (PCR) and nested reverse transcription PCR (RT-nested PCR) to characterize the aberrant transcripts. RT-nested PCR product sequencing comparison showed that c.3244-2A&gt;C splice-site mutation caused aberrant transcripts and formatted a new splice acceptor. Patient carrying the splice-site mutation c.3244-2A&gt;C presented early onset age, severe clinical manifestations, and poor prognosis. WD patients with the splice-site mutation show severe clinical manifestations, indicating that aberrant transcripts have important implications for WD phenotype.
			String line = value.toString();   
			String[] OneArticle = line.split("##");	 			
			PubMedID = OneArticle[0];		
			//String ArticleDate = OneArticle[1];		
			//String Title = OneArticle[2];					
			
			//reducerKey = ProjectTools.getMD5Checksum(value.getBytes());
			reducerKey = ProjectTools.getMD5Checksum(PubMedID.getBytes());
			
			log.info(filename +" : "+reducerKey);
		} catch (Exception e) {
			log.error(e.getMessage());
		}
		//context.write(new Text(reducerKey), new Text(filepath)); //key value for reducer
		context.write(new Text(reducerKey), new Text(PubMedID)); //key value for reducer
	}
}
