package org.windoop;

import java.io.IOException;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.util.Bytes;
import org.apache.log4j.Logger;

public class FileComparatorReducer extends 
	Reducer<Text,Text,Text,Text> {
	private static Logger log = Logger.getLogger(FileComparatorReducer.class);
	private String hbaseTableName = "PubMedID_Comparator";
	private String columnFamily = "Article";
	//private String qualifier = "path";
	private String qualifier = "PubMedID";
	private HbaseClient hbase;
	
	protected void setup(Context context) {
		log.info("Reducer Setup");
		hbase = new HbaseClient(hbaseTableName);
	}
	
	protected void cleanup(Context context) {// called at the end of the task
    	log.info("Reducer Cleanup");
	}
	
	public void reduce(Text key, Iterable<Text> values, Context context ) throws IOException, InterruptedException {
		Result result = hbase.getRow(key.toString());
		String filePath = " is not found.";		
		if(!result.isEmpty()) {//found in hbase
			filePath = new String(result.getValue(Bytes.toBytes(columnFamily),Bytes.toBytes(qualifier)));
			for (Text val :values) {
				context.write(val , new Text(filePath));
			}
		} else {
			int counter = 0;
			for (Text val :values) {
				//context.write(val , new Text(filePath));
				if(counter == 0) {
					hbase.putRow(columnFamily, qualifier, key.toString(), val.toString());					
					filePath = " is found as " + val.toString();
					counter++;
				}
			}
		}		
	}	
}

