package org.windoop;

import java.io.IOException;  
import java.util.ArrayList;
import java.util.List;
import org.apache.hadoop.conf.Configuration;  
//import org.apache.hadoop.hbase.*;  
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.util.Bytes;
import org.apache.log4j.Logger;

public class HbaseClient {
	private static Logger log = Logger.getLogger(HbaseClient.class);
	private HTable table;
	
	public HbaseClient(String tableName) {		
		Configuration conf = new Configuration();
		conf.set("fs.default.name","hdfs://localhost:9000");
		conf.set("mapred.job.tracker","localhost:9001");
		conf.set("hbase.rootdir","hdfs://localhost:9000/hbase");
		conf.set("hbase.zookeeper.quorum","localhost");
		conf.set("mapred.child.java.opts",  "-Xmx1g");
		conf.set("mapred.map.child.java.opts", "-Xmx1g");
		conf.set("mapred.reduce.child.java.opts", "-Xmx1g");
		
	    try {
	    	table = new HTable(conf, tableName);
		} catch (IOException e) {
	         log.error("IOException" , e);
		}
	}
	
	public void putRow(String columnFamily, String qualifier, String rowKey, String cellValue) {
		try {
			Put put = new Put(Bytes.toBytes(rowKey));
			put.add(Bytes.toBytes(columnFamily),Bytes.toBytes(qualifier),Bytes.toBytes(cellValue));
			table.put(put);
		}
		catch (IOException e) {
			log.error(e.getMessage());
		} 
	}
	
	public Result getRow(String rowKey)throws IOException {
		Get g = new Get(rowKey.getBytes());
		return table.get(g);
	}
	
	public void deleteRow(String rowkey) throws IOException {
		List<Delete> list = new ArrayList<Delete>();
		Delete d1 = new Delete(rowkey.getBytes());
		list.add(d1);
		table.delete(list);
		//log.info("Row deleted: " + rowkey);		
	}
}
